//
//  TESTAnimationFunctionView.m
//
//  Created by Thomas Wolters on 23/10/15.
//  Copyright © 2015 fluodmobile. All rights reserved.
//

#import "Demo1TimingFunctionView.h"

#define ELEMENT_OFFSET 50

@interface Demo1TimingFunctionView()
@property (nonatomic, assign) bool isLayouted; //hack
@property (nonatomic, assign) int visibleView;
@end

@implementation Demo1TimingFunctionView

- (instancetype)init{
    self = [super init];
    if (!self) {
        return nil;
    }
    self.backgroundColor = [UIColor whiteColor];
    self.visibleView = -2;
    NSMutableArray* views = [@[] mutableCopy];
    for (int i = 0; i<4;i++){
        UIView* view = [UIView new];
        view.backgroundColor = [Demo1TimingFunctionView disco];
        [self addSubview:view];
        [views    addObject:view];
        UITapGestureRecognizer* tapgesture = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(actionTap:)];
        [self addGestureRecognizer:tapgesture];
        view.alpha = 0;
    }
    [self actionTap:nil];
    self.views = views;
    return self;
}

-(void)layoutSubviews{
    if (self.isLayouted == NO){
        int i = 0;
        float elementHeight = (self.bounds.size.height - ([self.views count]+1)*ELEMENT_OFFSET ) / [self.views count];
        for (UIView* view in self.views){
            view.frame = (CGRect){BORDER_OFFSET, ELEMENT_OFFSET + i* (ELEMENT_OFFSET+elementHeight),ELEMENT_WIDTH,elementHeight};
            i++;
        }
        self.isLayouted =YES;
    }
}

+ (UIColor*)disco {
    CGFloat hue = arc4random() % 256 / 256.0;    //  0.0 to 1.0
    CGFloat saturation = (arc4random() % 128 / 256.0) + 0.5;    //  0.5 to 1.0, away from white
    CGFloat brightness = (arc4random() % 128 / 256.0) + 0.5;    //  0.5 to 1.0, away from black
    return [UIColor colorWithHue:hue saturation:saturation brightness:brightness alpha:1];
}

-(void)actionTap:(UITapGestureRecognizer*)tapGesture{
    self.visibleView++;
    if (self.visibleView > 3){
        self.visibleView = 3;
    }
    for (int i = 0; i <= self.visibleView; i++){
        UIView* view = self.views[i];
        view.alpha = 1;
    }
}

@end
