//
//  TESTTransitionAnimator.m
//
//  Created by Thomas Wolters on 22/10/15.
//  Copyright © 2015 fluodmobile. All rights reserved.
//

#import "Demo7TransitionAnimator.h"
#import "TESTBurningBottomView.h"

#define DURATION 5.0f

@interface Demo7TransitionAnimator()
@property (nonatomic, strong) id <UIViewControllerContextTransitioning>transitionContext;
@end

@implementation Demo7TransitionAnimator
- (NSTimeInterval)transitionDuration:(nullable id <UIViewControllerContextTransitioning>)transitionContext{
    return DURATION;
}

- (void)animateTransition:(id <UIViewControllerContextTransitioning>)transitionContext{
    self.transitionContext = transitionContext;

    UIView* containerView = transitionContext.containerView;
    
    UIView* toView = [transitionContext viewForKey:UITransitionContextToViewKey];
    toView.frame = containerView.frame;
    [containerView addSubview:toView];
    
    UIView* fromView = [transitionContext viewForKey:UITransitionContextFromViewKey];
    
    [containerView bringSubviewToFront:fromView];
    
    TESTBurningBottomView* viewBurningBottom = [TESTBurningBottomView new];
    viewBurningBottom.frame = containerView.frame;

    [containerView addSubview:viewBurningBottom];
    

    [UIView animateWithDuration:DURATION delay:0 options:UIViewAnimationOptionCurveEaseInOut animations:^{
        CGRect targetFrame = (CGRect){0,containerView.bounds.size.height*-1-50,containerView.bounds.size};
        viewBurningBottom.frame = targetFrame;
        fromView.frame = targetFrame;
    } completion:^(BOOL completition){
        [viewBurningBottom  removeFromSuperview];
        [self.transitionContext completeTransition:YES];
    }];
}


@end
