//
//  TESTSliderCell.m
//
//  Created by Thomas Wolters on 20/10/15.
//  Copyright © 2015 fluodmobile. All rights reserved.
//

#import "TESTSliderCell.h"

@interface TESTSliderCell()
@property (nonatomic, strong) UILabel* labelValue;
@property (nonatomic, strong) UISlider* slider;
@property (nonatomic, strong) NSString* attribute;
@property (nonatomic, assign) long index;
@end

@implementation TESTSliderCell


-(instancetype)initWithStyle:(UITableViewCellStyle)style reuseIdentifier:(NSString *)reuseIdentifier {
    self = [super initWithStyle:style reuseIdentifier:reuseIdentifier];
    self.selectionStyle = UITableViewCellSelectionStyleNone;
    self.backgroundColor = [UIColor lightGrayColor];

    
    self.slider = [UISlider new];
    self.slider.minimumValue = 0;
    [self.slider addTarget:self action:@selector(actionSliderChange:) forControlEvents:UIControlEventValueChanged];
    self.slider.maximumValue = 1;
    [self addSubview:self.slider];
    
    self.labelValue = [UILabel new];
    [self addSubview:self.labelValue];
    return self;
}

-(void)layoutSubviews{
    [super layoutSubviews];
    self.labelValue.frame = (CGRect){10,10,self.bounds.size.width-20,20};
    self.slider.frame = (CGRect){40,40,self.bounds.size.width-80,30};
}

-(void)actionSliderChange:(id)sender{
    [self updateLabel];
    [self.delegate userDidSelectValue:self.slider.value attribute:self.attribute index:self.index];
}

-(void)updateLabel{
    self.labelValue.text = [NSString stringWithFormat:@"%@ %1.2f",self.attribute, self.slider.value];
}
-(void)setAttribute:(NSString*)attribute value:(float)value minValue:(float)minValue maxValue:(float)maxValue index:(long)index{
    self.index = index;
    self.attribute = attribute;
    self.slider.minimumValue = minValue;
    self.slider.maximumValue = maxValue;
    self.slider.value = value;
    [self updateLabel];
}

-(void)prepareForReuse{
    self.delegate = nil;
    self.attribute = nil;
}

@end
